//+------------------------------------------------------------------+
//|                                            TriangleArbitrage.mq4 |
//|                               Copyright  2011, Yury V. Reshetov |
//|                                                  http://heigh.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Yury V. Reshetov"
#property link      "http://heigh.ru"

extern double lots = 1.0; //      EURUSD  EURJPY
extern double mn = 888; //  
extern int slp = 20; // 
static double pnt_eurusd = 0;
static double pnt_usdjpy = 0;
static double pnt_eurjpy = 0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   pnt_eurusd = slp;
   pnt_usdjpy = slp;
   pnt_eurjpy = slp;
   pnt_eurusd = pnt_eurusd * MarketInfo("EURUSD", MODE_POINT);
   pnt_usdjpy = pnt_usdjpy * MarketInfo("USDJPY", MODE_POINT);
   pnt_eurjpy = pnt_eurjpy * MarketInfo("EURJPY", MODE_POINT);

   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   
   //  ?
   if (! IsTradeAllowed()) {
      return(0);
   }
   
   //   ?
   if (MathAbs(MarketInfo("EURUSD", MODE_LOTSIZE) - MarketInfo("USDJPY", MODE_LOTSIZE)) > 0.5) {
      Alert(" ");
      return(0);
   }
   
   //   ?
   if (MathAbs(MarketInfo("EURUSD", MODE_LOTSIZE) - MarketInfo("EURJPY", MODE_LOTSIZE)) > 0.5) {
      Alert(" ");
      return(0);
   }
   
   //     0.01?
   if (MarketInfo("EURUSD", MODE_MINLOT) > 0.011) {
      Alert(" ");
      return(0);
   }

   RefreshRates();

   double p_eurusd = MarketInfo("EURUSD", MODE_BID);
   double p_usdjpy = MarketInfo("USDJPY", MODE_BID);
   double p_eurjpy = MarketInfo("EURJPY", MODE_ASK);

   int total = OrdersTotal();
   
   if (total > 0) {
      if (((p_eurusd - pnt_eurusd) * (p_usdjpy - pnt_usdjpy)) > (p_eurjpy + pnt_eurjpy)) {
         for (int i = 0; i < total; i++) {
            OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if (OrderMagicNumber() == mn) {
               if (OrderSymbol() == "EURUSD") {
                  while(! IsTradeAllowed()) {
                     Sleep(10);
                     if (IsStopped()) {
                        return(0);
                     }
                  }
                  OrderClose(OrderTicket(), OrderLots(), p_eurusd, slp, Red);
               }
               if (OrderSymbol() == "USDJPY") {
                  while(! IsTradeAllowed()) {
                     Sleep(10);
                     if (IsStopped()) {
                        return(0);
                     }
                  }
                  OrderClose(OrderTicket(), OrderLots(), p_usdjpy, slp, Red);
               }
               if (OrderSymbol() == "EURJPY") {
                  while(! IsTradeAllowed()) {
                     Sleep(10);
                     if (IsStopped()) {
                        return(0);
                     }
                  }
                  OrderClose(OrderTicket(), OrderLots(), p_eurjpy, slp, Blue);
               }
            }
         }
         return(0);
      }
   }
   
   RefreshRates();

   p_eurusd = MarketInfo("EURUSD", MODE_ASK);
   p_usdjpy = MarketInfo("USDJPY", MODE_ASK);
   p_eurjpy = MarketInfo("EURJPY", MODE_BID);

   if (((p_eurusd + pnt_eurusd) * (p_usdjpy + pnt_usdjpy)) < (p_eurjpy - pnt_eurjpy)) {
      
      OrderSend("EURUSD", OP_BUY, lots, p_eurusd, slp, 0, 0, WindowExpertName(), mn, 0, Blue);
      
      while(! IsTradeAllowed()) {
         Sleep(10);
         if (IsStopped()) {
            return(0);
         }
      }
      
      OrderSend("EURJPY", OP_SELL, lots, p_eurjpy, slp, 0, 0, WindowExpertName(), mn, 0, Red);
      
      double lt = lots * p_eurusd + 0.005;
      lt = NormalizeDouble(lt, 2);
      
      while(! IsTradeAllowed()) {
         Sleep(10);
         if (IsStopped()) {
            return(0);
         }
      }

      OrderSend("USDJPY", OP_BUY, lt, p_usdjpy, slp, 0, 0, WindowExpertName(), mn, 0, Blue);
      
   }
   return(0);
  }
//+------------------------------------------------------------------+